ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
c   subroutine for the (time dependent) boundary condition of the
c   induction equation
c    bnd(tin), where tin is the time 
c***********************************************************************
C   update log
c   sept., 18, 2000 topax multiplied by 10000 (Fumiko)
c   Feb. 24, 1999  localize array
c   Oct. 15, 1998  periodic BC in x, y
C   Sep.  1, 1998  coded by W. Chou
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
      subroutine bnd(tin)
      include 'common.grid'
      include 'common.field'
      include 'common.para'
      parameter(dist=100.0,a0=10.0, slopeA=0.1)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
c   define the function form in top and bottom boundary for ax, ay, az
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
c     fx(xx,yy,zz,tt)=(2*slopeA*xx*omega*tt+slopeA*yy*cos(2*omega*tt)
c    &  +4*a0*sin(omega*tt)-4*slopeA*dist*sin(omega*tt)
c    &  +slopeA*xx*sin(2*omega*tt) )/(4*omega)
c     fy(xx,yy,zz,tt)=(-2*slopeA*yy*omega*tt+slopeA*yy*sin(2*omega*tt)
c    &  -4*a0*cos(omega*tt)+4*slopeA*dist*cos(omega*tt)
c    &  -slopeA*xx*cos(2*omega*tt) )/(4*omega)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
      botax(xx,yy,zz,tt)=0.0
      botay(xx,yy,zz,tt)=0.0
      botaz(xx,yy,zz,tt)=0.0
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
c       multiplied by 10000 after bnd.f.mt3.chou (9/18/00)

      topax(xx,yy,zz,tt)= 10000*sin(omega*tt)
c     topay(xx,yy,zz,tt)=sin(omega*tt)
c     topaz(xx,yy,zz,tt)=sin(omega*tt)
      topay(xx,yy,zz,tt)=0
      topaz(xx,yy,zz,tt)=0
c     topaz(xx,yy,zz,tt)=cos(omega*tt-wx*(xx-x0)-wy*(yy-y0))
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
      x0=x(1)
      y0=y(1)
      xl=x(ixx)-x(1)
      yl=y(jxx)-y(1)
      wx=p2/xl
      wy=p2/yl
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
c    z-boundary
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
      if (myrank == 0) then
        do j=1,jx
        do i=1,ix
          ax(i,j,0)=botax(x(i),y(j),z(0),tin)
          ay(i,j,0)=botay(x(i),y(j),z(0),tin)
          az(i,j,0)=botaz(x(i),y(j),z(0),tin)
        enddo
        enddo
      endif
      if (myrank == lastrank) then
        do j=1,jx
        do i=1,ix
          ax(i,j,kxx)=topax(x(i),y(j),z(kxx),tin)
          ay(i,j,kxx)=topay(x(i),y(j),z(kxx),tin)
          az(i,j,kxx)=topaz(x(i),y(j),z(kxx),tin)
        enddo
        enddo
      endif
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
c    y-boundary
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
      do k=0,kxx
      do i=1,ix
c        ax(i,0,k)=fx(x(i),y(0),z(k),tin)
c        ax(i,jxx,k)=fx(x(i),y(jxx),z(k),tin)
c        ay(i,0,k)=fy(x(i),y(0),z(k),tin)
c        ay(i,jxx,k)=fy(x(i),y(jxx),z(k),tin)
c        az(i,0,k)=fz(x(i),y(0),z(k),tin)
c        az(i,jxx,k)=fz(x(i),y(jxx),z(k),tin)
         ax(i,0,k)=ax(i,jx,k)
         ax(i,jxx,k)=ax(i,1,k)
         ay(i,0,k)=ay(i,jx,k)
         ay(i,jxx,k)=ay(i,1,k)
         az(i,0,k)=az(i,jx,k)
         az(i,jxx,k)=az(i,1,k)
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
c    x-boundary
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70cc
      do k=0,kxx
      do j=0,jxx
c        ax(0,j,k)=fx(x(0),y(j),z(k),tin)
c        ax(ixx,j,k)=fx(x(ixx),y(j),z(k),tin)
c        ay(0,j,k)=fy(x(0),y(j),z(k),tin)
c        ay(ixx,j,k)=fy(x(ixx),y(j),z(k),tin)
c        az(0,j,k)=fz(x(0),y(j),z(k),tin)
c        az(ixx,j,k)=fz(x(ixx),y(j),z(k),tin)
         ax(0,j,k)=ax(ix,j,k)
         ax(ixx,j,k)=ax(1,j,k)
         ay(0,j,k)=ay(ix,j,k)
         ay(ixx,j,k)=ay(1,j,k)
         az(0,j,k)=az(ix,j,k)
         az(ixx,j,k)=az(1,j,k)
      enddo
      enddo
      return
      end
