ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     preconditioner subroutine for ICCG
c      calculate D such that L*D*Lt=A
C**********************************************************************
C   update log
C   Feb. 25, 1999  reduce array size by localizing the array
C   jan. 24, 1999  less parameters
C   Dec. 27, 1998  vectorize, no MPI, seperated from iccg.f
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      subroutine decomp(mx,my,mz)
      include 'common.grid'
      include 'common.mat'
      include 'common.para'
      a5=-0.5/dy**2
      a6=-0.5/dx**2
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c       wait here before receiving message from the previous CPU
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
        if (myrank /= 0) then
          call mpi_irecv(diagmat(1,1,ksta-1),1,ionelayer,
     &                   idown,1,mpi_comm_world,ireqrr,ierr)
          call mpi_wait(ireqrr,istatus,ierr)
        endif
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c   calculate D such that L*D*Lt=A
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      lh=mx+my+mz-2
      do l=3,lh
       ml=max(2,l-mx+1)
       mh=min(l-1,my+mz-1)
      do m=ml,mh
       kl=max(1,m-my+1)
       kh=min(m-1,mz)
      do k=kl,kh
         i=l-m
         j=m-k
         diagmat(i,j,k)=1/( smain(i,j,k,1)
     &             -diagmat(i,j,k-1)*smain(i,j,k,2)**2
     &             -diagmat(i,j-1,k)*smain(i,j,k,3)**2
     &             -diagmat(i-1,j,k)*smain(i,j,k,4)**2 )
      enddo
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     before vectorized
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do k=1,mz
c     do j=1,my-1
c     do i=1,mx-1
c        diagmat(i,j,k)=1/( smain(i,j,k,1)
c    &             -diagmat(i,j,k-1)*smain(i,j,k,2)**2
c    &             -diagmat(i,j-1,k)*smain(i,j,k,3)**2
c    &             -diagmat(i-1,j,k)*smain(i,j,k,4)**2 )
c     enddo
c     enddo
c     enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     boundary terms
c     note that only mx,my terms are affected, but not x=1,y=1 terms
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      lh=mx+mz-1
      do l=2,lh
        kmin=max(1,l-mx+1)
        kmax=min(l-1,mz)
      do k=kmin,kmax
         i=l-k
         diagmat(i,my,k)=1/( smain(i,my,k,1)
     &           -diagmat(i,my,k-1)*smain(i,my,k,2)**2
     &           -diagmat(i,my-1,k)*smain(i,my,k,3)**2
     &           -diagmat(i-1,my,k)*smain(i,my,k,4)**2
     &           -diagmat(i,1,k)*a5**2 )
      enddo
      enddo
      lh=my+mz-1
      do l=2,lh
        kmin=max(1,l-my+1)
        kmax=min(l-1,mz)
      do k=kmin,kmax
        j=l-k
         diagmat(mx,j,k)=1/( smain(mx,j,k,1)
     &           -diagmat(mx,j,k-1)*smain(mx,j,k,2)**2
     &           -diagmat(mx,j-1,k)*smain(mx,j,k,3)**2
     &           -diagmat(mx-1,j,k)*smain(mx,j,k,4)**2
     &           -diagmat(1,j,k)*a6**2)
      enddo
      enddo
      do k=1,mz
         diagmat(mx,my,k)=1/( smain(mx,my,k,1)
     &           -diagmat(mx,my,k-1)*smain(mx,my,k,2)**2
     &           -diagmat(mx,my-1,k)*smain(mx,my,k,3)**2
     &           -diagmat(mx-1,my,k)*smain(mx,my,k,4)**2
     &           -diagmat(mx,1,k)*a5**2-diagmat(1,my,k)*a6**2)
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     before vectorized
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do k=1,mz
c       do i=1,mx-1
c         diagmat(i,my,k)=1/( smain(i,my,k,1)
c    &           -diagmat(i,my,k-1)*smain(i,my,k,2)**2
c    &           -diagmat(i,my-1,k)*smain(i,my,k,3)**2
c    &           -diagmat(i-1,my,k)*smain(i,my,k,4)**2
c    &           -diagmat(i,1,k)*a5**2 )
c       enddo
c       do j=1,my-1
c         diagmat(mx,j,k)=1/( smain(mx,j,k,1)
c    &           -diagmat(mx,j,k-1)*smain(mx,j,k,2)**2
c    &           -diagmat(mx,j-1,k)*smain(mx,j,k,3)**2
c    &           -diagmat(mx-1,j,k)*smain(mx,j,k,4)**2
c    &           -diagmat(1,j,k)*a6**2)
c       enddo
c       diagmat(mx,my,k)=1/( smain(mx,my,k,1)
c    &           -diagmat(mx,my,k-1)*smain(mx,my,k,2)**2
c    &           -diagmat(mx,my-1,k)*smain(mx,my,k,3)**2
c    &           -diagmat(mx-1,my,k)*smain(mx,my,k,4)**2
c    &           -diagmat(mx,1,k)*a5**2-diagmat(1,my,k)*a6**2)
c     enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     finish one CPU, send it to the next CPU
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
        if (myrank /= lastrank) then
          call mpi_send(diagmat(1,1,kend),1,ionelayer,
     &                     iup,1,mpi_comm_world,ierr)
        endif
      return
      end
