C*************************************
      SUBROUTINE FILE
C*************************************
c     calculate B field and save B and E as output results
C======================================================================
C     update log
C     Feb. 24, 1999  localize array
C     Sep. 29, 1998  save B,E instead of A
C     Sep.  1, 1998  coded by W. Chou based on Dr. Matsumoto's mhd code
C======================================================================
c     include 'precision'
      include 'common.grid'
      include 'common.field'
      include 'common.para'
      dimension buf(0:nx,0:ny,0:nzg)
      dimension ireqr(0:ncpu-1),ireqs(6)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     send/receive boundary terms before each calculation
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      call mpi_sendrecv(ax(0,0,kend),1,ioneplus,iup,1,
     &               ax(0,0,ksta-1),1,ioneplus,idown,1,
     &               mpi_comm_world,istatus,ierr)
      call mpi_sendrecv(ax(0,0,ksta),1,ioneplus,idown,1,
     &               ax(0,0,kend+1),1,ioneplus,iup,1,
     &               mpi_comm_world,istatus,ierr)
c     call mpi_sendrecv(ay(0,0,kend),1,ioneplus,iup,2,
c    &               ay(0,0,ksta-1),1,ioneplus,idown,2,
c    &               mpi_comm_world,istatus,ierr)
c     call mpi_sendrecv(ay(0,0,ksta),1,ioneplus,idown,2,
c    &               ay(0,0,kend+1),1,ioneplus,iup,2,
c    &               mpi_comm_world,istatus,ierr)
c     call mpi_sendrecv(az(0,0,kend),1,ioneplus,iup,3,
c    &               az(0,0,ksta-1),1,ioneplus,idown,3,
c    &               mpi_comm_world,istatus,ierr)
c     call mpi_sendrecv(az(0,0,ksta),1,ioneplus,idown,3,
c    &               az(0,0,kend+1),1,ioneplus,iup,3,
c    &               mpi_comm_world,istatus,ierr)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     Magnetic field B=Curl A
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
          DO  K=1,KX
          DO  J=1,JX
          DO  I=1,IX
            BX(I,J,K) = (AZ(I,J+1,K)-AZ(I,J-1,K))/(Y(J+1)-Y(J-1))
     &                 -(AY(I,J,K+1)-AY(I,J,K-1))/(Z(K+1)-Z(K-1))
c           BY(I,J,K) = (AX(I,J,K+1)-AX(I,J,K-1))/(Z(K+1)-Z(K-1))
c    &                 -(AZ(I+1,J,K)-AZ(I-1,J,K))/(X(I+1)-X(I-1))
            BY(I,J,K) = (AX(I,J,K+1)-AX(I,J,K-1))/(-Z(K+1)+Z(K-1))
     &                 -(AZ(I+1,J,K)-AZ(I-1,J,K))/(X(I+1)-X(I-1))
            BZ(I,J,K) = (AY(I+1,J,K)-AY(I-1,J,K))/(X(I+1)-X(I-1))
     &                 -(AX(I,J+1,K)-AX(I,J-1,K))/(Y(J+1)-Y(J-1))
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c    non-uniform grid
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c           BX(I,J,K) = 0.5*( (AZ(I,J+1,K)-AZ(I,J,K)) / (Y(J+1)-Y(J))
c    &                  +(AZ(I,J,K)-AZ(I,J-1,K)) / (Y(J)-Y(J-1))
c    &                  -(AY(I,J,K+1)-AY(I,J,K)) / (Z(K+1)-Z(K))
c    &                  -(AY(I,J,K)-AY(I,J,K-1)) /(Z(K)-Z(K-1))   )
c           BY(I,J,K) = 0.5*( (AX(I,J,K+1)-AX(I,J,K)) / (Z(K+1)-Z(K))
c    &                  +(AX(I,J,K)-AX(I,J,K-1)) / (Z(K+1)-Z(K-1))
c    &                  -(AZ(I+1,J,K)-AZ(I,J,K)) / (X(I+1)-X(I))
c    &                  -(AZ(I,J,K)-AZ(I-1,J,K)) / (X(I)-X(I-1))  )
c           BZ(I,J,K) = 0.5*( (AY(I+1,J,K)-AY(I,J,K)) / (X(I+1)-X(I))
c    &                  + (AY(I,J,K)-AY(I-1,J,K)) / (X(I)-X(I-1))
c    &                  -(AX(I,J+1,K)-AX(I,J,K)) / (Y(J+1)-Y(J))
c    &                  -(AX(I,J,K)-AX(I,J-1,K)) / (Y(J)-Y(J-1))  )
      enddo
      enddo 
      enddo
100   CONTINUE
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     periodic boundary terms
c    y-boundary
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      do k=0,kxx
      do i=1,ix
         bx(i,0,k)=bx(i,jx,k)
         bx(i,jxx,k)=bx(i,1,k)
         by(i,0,k)=by(i,jx,k)
         by(i,jxx,k)=by(i,1,k)
         bz(i,0,k)=bz(i,jx,k)
         bz(i,jxx,k)=bz(i,1,k)
         ex(i,0,k)=ex(i,jx,k)
         ex(i,jxx,k)=ex(i,1,k)
         ey(i,0,k)=ey(i,jx,k)
         ey(i,jxx,k)=ey(i,1,k)
         ez(i,0,k)=ez(i,jx,k)
         ez(i,jxx,k)=ez(i,1,k)
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c    x-boundary
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      do k=0,kxx
      do j=0,jxx
         bx(0,j,k)=bx(ix,j,k)
         bx(ixx,j,k)=bx(1,j,k)
         by(0,j,k)=by(ix,j,k)
         by(ixx,j,k)=by(1,j,k)
         bz(0,j,k)=bz(ix,j,k)
         bz(ixx,j,k)=bz(1,j,k)
         ex(0,j,k)=ex(ix,j,k)
         ex(ixx,j,k)=ex(1,j,k)
         ey(0,j,k)=ey(ix,j,k)
         ey(ixx,j,k)=ey(1,j,k)
         ez(0,j,k)=ez(ix,j,k)
         ez(ixx,j,k)=ez(1,j,k)
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
C     pass message to root in order to output
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      if (myrank /= 0) then
c       call mpi_isend(bx(0,0,ksta),1,itype(myrank),0,1,
c    &                    mpi_comm_world,ireqs(1),ierr)
        call mpi_isend(by(0,0,ksta),1,itype(myrank),0,2,
     &                    mpi_comm_world,ireqs(2),ierr)
        call mpi_isend(bz(0,0,ksta),1,itype(myrank),0,3,
     &                    mpi_comm_world,ireqs(3),ierr)
        call mpi_isend(ex(0,0,ksta),1,itype(myrank),0,4,
     &                    mpi_comm_world,ireqs(4),ierr)
c       call mpi_isend(ey(0,0,ksta),1,itype(myrank),0,5,
c    &                    mpi_comm_world,ireqs(5),ierr)
c       call mpi_isend(ez(0,0,ksta),1,itype(myrank),0,6,
c    &                    mpi_comm_world,ireqs(6),ierr)
c       do imesg=1,6
c         call mpi_wait(ireqs(imesg),istatus,ierr)
c       enddo
        call mpi_wait(ireqs(2),istatus,ierr)
        call mpi_wait(ireqs(3),istatus,ierr)
        call mpi_wait(ireqs(4),istatus,ierr)
      else
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     rank 0, collect message and write data to file
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
        WRITE(2) NS,TIME
c ---bx
c       do irank=1,lastrank
c         call mpi_irecv(buf(0,0,kksta(irank)),1,itype(irank),irank,1,
c    &                          mpi_comm_world,ireqr(irank),ierr)
c       enddo
c       do k=0,kx
c       do j=0,jxx
c       do i=0,jxx
c         buf(i,j,k)=bx(i,j,k)
c       enddo
c       enddo
c       enddo
c       do irank=1,lastrank
c         call mpi_wait(ireqr(irank),istatus,ierr)
c       enddo
c       WRITE(2) (((buf(I,J,K),I=0,IXX),J=0,JXX),K=0,KXG+1)
c ---by
        do irank=1,lastrank
          call mpi_irecv(buf(0,0,kksta(irank)),1,itype(irank),irank,2,
     &                          mpi_comm_world,ireqr(irank),ierr)
        enddo
        do k=0,kx
        do j=0,jxx
        do i=0,jxx
          buf(i,j,k)=by(i,j,k)
        enddo
        enddo
        enddo
        do irank=1,lastrank
          call mpi_wait(ireqr(irank),istatus,ierr)
        enddo
c       WRITE(2) (((buf(I,J,K),I=0,IXX),J=0,JXX),K=0,KXG+1)
        WRITE(2) ((buf(I,J,KXg),I=0,IXX),J=0,JXX)
c ---bz
        do irank=1,lastrank
          call mpi_irecv(buf(0,0,kksta(irank)),1,itype(irank),irank,3,
     &                          mpi_comm_world,ireqr(irank),ierr)
        enddo
        do k=0,kx
        do j=0,jxx
        do i=0,jxx
          buf(i,j,k)=bz(i,j,k)
        enddo
        enddo
        enddo
        do irank=1,lastrank
          call mpi_wait(ireqr(irank),istatus,ierr)
        enddo
c       WRITE(2) (((buf(I,J,K),I=0,IXX),J=0,JXX),K=0,KXG+1)
        WRITE(2) ((buf(I,J,Kxg),I=0,IXX),J=0,JXX)
c ---ex
        do irank=1,lastrank
          call mpi_irecv(buf(0,0,kksta(irank)),1,itype(irank),irank,4,
     &                          mpi_comm_world,ireqr(irank),ierr)
        enddo
        do k=0,kx
        do j=0,jxx
        do i=0,jxx
          buf(i,j,k)=ex(i,j,k)
        enddo
        enddo
        enddo
        do irank=1,lastrank
          call mpi_wait(ireqr(irank),istatus,ierr)
        enddo
c       WRITE(2) (((buf(I,J,K),I=0,IXX),J=0,JXX),K=0,KXG+1)
        WRITE(2) ((buf(I,J,Kxg),I=0,IXX),J=0,JXX)
c ---ey
c       do irank=1,lastrank
c         call mpi_irecv(buf(0,0,kksta(irank)),1,itype(irank),irank,5,
c    &                          mpi_comm_world,ireqr(irank),ierr)
c       enddo
c       do k=0,kx
c       do j=0,jxx
c       do i=0,jxx
c         buf(i,j,k)=ey(i,j,k)
c       enddo
c       enddo
c       enddo
c       do irank=1,lastrank
c         call mpi_wait(ireqr(irank),istatus,ierr)
c       enddo
c       WRITE(2) (((buf(I,J,K),I=0,IXX),J=0,JXX),K=0,KXG+1)
c ---ez
c       do irank=1,lastrank
c         call mpi_irecv(buf(0,0,kksta(irank)),1,itype(irank),irank,6,
c    &                          mpi_comm_world,ireqr(irank),ierr)
c       enddo
c       do k=0,kx
c       do j=0,jxx
c       do i=0,jxx
c         buf(i,j,k)=ez(i,j,k)
c       enddo
c       enddo
c       enddo
c       do irank=1,lastrank
c         call mpi_wait(ireqr(irank),istatus,ierr)
c       enddo
c       WRITE(2) (((buf(I,J,K),I=0,IXX),J=0,JXX),K=0,KXG+1)
        WRITE(6,610) NS,TIME
      endif
610   FORMAT(' FILE OUTPUT AT NS = ',I8,' TIME = ',1PE12.3///)
      RETURN
      END
