ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c        
c   initialize all the matrixes with 5 layeras wt anomalies
c                    init.f.5lyrs.anomaly.3.4.5.layrs
C**********************************************************************
C   update log
c   April 13, 2001 revised for 5 layers wt anomalies
C   Feb. 25, 1999  localize array
C   Oct. 15, 1998  periodic boundary for x and y
C   Sep.  1, 1998  coded by W. Chou
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      subroutine init 
      include 'common.grid'
      include 'common.field'
      include 'common.mat'
      include 'common.para'
      include 'common.anmly'
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     set conductivity
c      XLENGTH: z of high conduction region
c      amp: rate of change of sigma in shallow region
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      xk=p2/(x(ix)-x(0))
      yk=p2/(y(jx)-y(0))
      do k=1,kx
      do j=1,jx
      do i=1,ix
c       r2=(x(i)-x(ic))**2+(y(j)-y(jc))**2+(z(k)-z(kc))**2
c       r=sqrt(r2)

c****** 1st layer ******

        IF (Z(K) .ge. depth(1))  then

        if (ext1.gt.0.) then

           if (  (abs(x(i)) < ext1*x(ix) ) .and.
     &          (abs(y(j)) < ext1*y(jx) )) then

             sigma(i,j,k)=sigma0(1)*alph1
           else

             sigma(i,j,k)=sigma0(1)
           endif

        else
             sigma(i,j,k)=sigma0(1)
        endif

c           sigma(i,j,k)=sigma0(1)*(1+alph1*sin(xk*x(i))*sin(yk*y(j)) )

c****** 2nd layer ******

        ELSE IF (Z(K) .ge. depth(2)) then

c           sigma(i,j,k)=sigma0(2)*(1+alph2*sin(xk*x(i))*sin(yk*y(j)) )
        if (ext2.gt.0.) then

           if (  (abs(x(i)) < ext2*x(ix) ) .and.
     &          (abs(y(j)) < ext2*y(jx) )) then

             sigma(i,j,k)=sigma0(2)*alph1
           else

             sigma(i,j,k)=sigma0(2)
           endif

        else
             sigma(i,j,k)=sigma0(2)
        endif


c******  Flattened anomaly in the 3rd layer ******

        ELSE IF (Z(K) .ge. depth(3)) then

c          sigma(i,j,k)=sigma0(3)*(1+0.8*sin(xk*x(i))*sin(yk*y(j)) )
c
        if (ext3.gt.0) then
     
           if (  (abs(x(i)) < ext3*x(ix) ) .and.
     &          (abs(y(j)) < ext3*y(jx) )) then

             sigma(i,j,k)=sigma0(3)*alph3
           else
             sigma(i,j,k)=sigma0(3)
           endif

        else
             sigma(i,j,k)=sigma0(3)
        endif 

       
c ****** Anomaly in the 4th layer (4/13/01) ******
c                (after 'init.f' in chou/earth/mt3)
c
         ELSE IF (Z(K) .ge. depth(4)) then
c           sigma(i,j,k)=sigma0(4)*(1+0.0*sin(xk*x(i))*sin(yk*y(j)) )

        if (ext4.gt.0) then

           if ( abs(x(i)) < ext4*x(ix) .and.
     &         abs(y(j)) < ext4*y(jx) ) then

             sigma(i,j,k)=sigma0(4)*alph4
           else
             sigma(i,j,k)=sigma0(4)
           endif

        else
             sigma(i,j,k)=sigma0(4)
        endif


        ELSE

c ****** Anomaly in the 5th layer (5/14/01) ******

        if (ext5.gt.0) then  

          if ( abs(x(i)) < ext5*x(ix) .and.
     &         abs(y(j)) < ext5*y(jx) ) then
            sigma(i,j,k)=sigma0(5)*alph5
          else
            sigma(i,j,k)=sigma0(5)
          endif

        else
            sigma(i,j,k)=sigma0(5)
        endif

c           sigma(i,j,k)=sigma0(5)*(1+0.0*sin(xk*x(i))*sin(yk*y(j)) )
c        sigma(i,j,k)=100.1-100*((z(k)-z(1))/(z(kx)-z(1)))
c        sigma(i,j,k)=4-amp*(z(k)-z(kx) )

         ENDIF
      enddo
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     set main matrix
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      do k=0,kxx
      do j=1,jx
      do i=1,ix
        smain(i,j,k,1)=sigma(i,j,k)/dt+(1/dx**2+1/dy**2+1/dz**2)
        smain(i,j,k,2)=-0.5/dz**2
        smain(i,j,k,3)=-0.5/dy**2
        smain(i,j,k,4)=-0.5/dx**2
        smain(i,j,k,5)= 0.0
        smain(i,j,k,6)= 0.0
      enddo
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     periodic boundary terms
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      do k=1,kx
       do i=1,ix
          smain(i,1,k,5)=-0.5/dy**2
          smain(i,jx,k,5)=-0.5/dy**2
       enddo
       do j=1,jx
          smain(1,j,k,6)=-0.5/dx**2
          smain(ix,j,k,6)=-0.5/dx**2
       enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     initialize matrix T
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      do k=0,kxx
      do j=0,jxx
      do i=0,ixx
         tmain(i,j,k,1)=sigma(i,j,k)/dt-(1/dx**2+1/dy**2+1/dz**2)
         tmain(i,j,k,2)=0.5/dz**2
         tmain(i,j,k,3)=0.5/dy**2
         tmain(i,j,k,4)=0.5/dx**2
         tmain(i,j,k,5)=0.0
         tmain(i,j,k,6)=0.0
      enddo
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     periodic boundary terms
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      do k=1,kx
       do i=1,ix
          tmain(i,1,k,5)=0.5/dy**2
          tmain(i,jx,k,5)=0.5/dy**2
       enddo
       do j=1,jx
          tmain(1,j,k,6)=0.5/dx**2
          tmain(ix,j,k,6)=0.5/dx**2
       enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     set the boundary of the main matrix equal to zero
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      do k=0,kxx
      do j=0,jxx
      do i=0,ixx
        do n=1,6
         smain(i,0,k,n)=0.0
         smain(i,jxx,k,n)=0.0
         smain(0,j,k,n)=0.0
         smain(ixx,j,k,n)=0.0
         tmain(i,0,k,n)=0.0
         tmain(i,jxx,k,n)=0.0
         tmain(0,j,k,n)=0.0
         tmain(ixx,j,k,n)=0.0
        enddo
        smain(1,j,k,4)=0.0
        smain(i,1,k,3)=0.0
        tmain(1,j,k,4)=0.0
        tmain(i,1,k,3)=0.0
      enddo
      enddo
      enddo
      if (myrank == 0) then
        do j=0,jxx
        do i=0,ixx
          do n=1,6
            smain(i,j,0,n)=0.0
          enddo
          smain(i,j,1,2)=0.0
        enddo
        enddo
      endif
      if (myrank == lastrank) then
        do j=0,jxx
        do i=0,ixx
          do n=1,6
            smain(i,j,kxx,n)=0.0
          enddo
        enddo
        enddo
      endif
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c       the top and bottom boundary terms should be included in
c       the matrix multiplication, so the following statements
c       are not needed
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c        tmain(i,j,0,n)=0.0
c        tmain(i,j,kxx,n)=0.0
c       tmain(i,j,1,2)=0.0
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c   initialize AX, AY, AZ at t=0, the boundary terms will be determined
c   later in subroutine bnd
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      lx=x(ixx)-x(0)
      ly=y(jxx)-y(0)
      do k=1,kx
      do j=1,jx
      do i=1,ix
        ax(i,j,k)=0.0
        ay(i,j,k)=0.0
        az(i,j,k)=0.0
c      az(i,j,k)=0.1*x(i)
c      az(i,j,k)=10*sin(2*pai*(x(i)-x(0))/lx)*sin(2*pai*(y(j)-y(0))/ly)
      enddo
      enddo
      enddo
      return
      end
