ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     subroutine ldlt called by iccg
c     in order to calculate yout=(l d lt)^(-1) xin
c     D has been calculated by iccg
C**********************************************************************
C   update log
c   Jan. 24, 1999  less parameters
c   Jan. 21, 1999  do not use k in vector direction
C   Jan. 20, 1999  MPI, but no mesage passing (localize)
C   Nov. 18, 1998  vectorize for induction solver
C   Oct. 16, 1998  for ICCG of periodic BC
C   Sep.  1, 1998  coded by W. Chou, based on the example in IBM manual
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      subroutine ldlt(xin,yout,mx,my,mz)
      include 'common.grid'
      include 'common.para'
      include 'common.mat'
      real xin(0:nx,0:ny,0:nz),yout(0:nx,0:ny,0:nz)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c    first step: (xin=L ytemp), where (ytemp=D Lt yout)
c    vectorize: m=i+j, process in the direction of
c               constant l,m terms first
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      a5=-0.5/dy**2
      a6=-0.5/dx**2
      mh=mx+my-2
      do k=ksta,kend
      do m=2,mh
        il=max(1,m-my+1)
        ih=min(mx-1,m-1)
      do i=il,ih
        j=m-i
        yout(i,j,k)=diagmat(i,j,k)*( xin(i,j,k)
     &       -yout(i,j,k-1)*smain(i,j,k,2)-yout(i,j-1,k)*smain(i,j,k,3)
     &       -yout(i-1,j,k)*smain(i,j,k,4) )
      enddo
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c      before vectorize
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do i=1,mx-1
c     do j=1,my-1
c     do k=ksta.kend
c       yout(i,j,k)=diagmat(i,j,k)*( xin(i,j,k)
c    &       -yout(i,j,k-1)*smain(i,j,k,2)-yout(i,j-1,k)*smain(i,j,k,3)
c    &       -yout(i-1,j,k)*smain(i,j,k,4) )
c     enddo
c     enddo
c     enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     boundary terms
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      lh=mx+kend-1
      do l=ksta+1,lh
        kmin=max(ksta,l-mx+1)
        kmax=min(l-1,kend)
      do k=kmin,kmax
        i=l-k
        yout(i,my,k)=diagmat(i,my,k)*( xin(i,my,k)
     &                -yout(i,my,k-1)*smain(i,my,k,2)
     &                -yout(i,my-1,k)*smain(i,my,k,3)
     &                -yout(i-1,my,k)*smain(i,my,k,4)-yout(i,1,k)*a5 )
      enddo
      enddo
      lh=my+kend-1
      do l=ksta+1,lh
        kmin=max(ksta,l-my+1)
        kmax=min(l-1,kend)
      do k=kmin,kmax
        j=l-k
        yout(mx,j,k)=diagmat(mx,j,k)*( xin(mx,j,k)
     &                -yout(mx,j,k-1)*smain(mx,j,k,2)
     &                -yout(mx,j-1,k)*smain(mx,j,k,3)
     &                -yout(mx-1,j,k)*smain(mx,j,k,4)-yout(1,j,k)*a6 )
      enddo
      enddo
      do k=ksta,kend
        yout(mx,my,k)=diagmat(mx,my,k)*( xin(mx,my,k)
     &                 -yout(mx,my,k-1)*smain(mx,my,k,2)
     &                 -yout(mx,my-1,k)*smain(mx,my,k,3)
     &                 -yout(mx-1,my,k)*smain(mx,my,k,4)
     &                 -yout(mx,1,k)*a5-yout(1,my,k)*a6 )
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c      before vectorize
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do k=ksta,kend
c       do i=1,mx-1
c         yout(i,my,k)=diagmat(i,my,k)*( xin(i,my,k)
c    &                -yout(i,my,k-1)*smain(i,my,k,2)
c    &                -yout(i,my-1,k)*smain(i,my,k,3)
c    &                -yout(i-1,my,k)*smain(i,my,k,4)-yout(i,1,k)*a5 )
c       enddo
c       do j=1,my-1
c         yout(mx,j,k)=diagmat(mx,j,k)*( xin(mx,j,k)
c    &                -yout(mx,j,k-1)*smain(mx,j,k,2)
c    &                -yout(mx,j-1,k)*smain(mx,j,k,3)
c    &                -yout(mx-1,j,k)*smain(mx,j,k,4)-yout(1,j,k)*a6 )
c       enddo
c       yout(mx,my,k)=diagmat(mx,my,k)*( xin(mx,my,k)
c    &                 -yout(mx,my,k-1)*smain(mx,my,k,2)
c    &                 -yout(mx,my-1,k)*smain(mx,my,k,3)
c    &                 -yout(mx-1,my,k)*smain(mx,my,k,4)
c    &                 -yout(mx,1,k)*a5-yout(1,my,k)*a6 )
c     enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c      second step, use (ytemp=D Lt yout) to find yout
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      mh=mx+my
      do k=kend,ksta,-1
      do m=mh,4,-1
        il=max(2,m-my)
        ih=min(m-2,mx)
      do i=ih,il,-1
        j=m-i
        yout(i,j,k)=yout(i,j,k)-diagmat(i,j,k)*( 
     &         yout(i,j,k+1)*smain(i,j,k+1,2)
     &        +yout(i,j+1,k)*smain(i,j+1,k,3)
     &        +yout(i+1,j,k)*smain(i+1,j,k,4) )
      enddo
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c      before vectorize
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do k=kend,ksta,-1
c     do j=my,2,-1
c     do i=mx,2,-1
c       yout(i,j,k)=yout(i,j,k)-diagmat(i,j,k)*( 
c    &         yout(i,j,k+1)*smain(i,j,k+1,2)
c    &        +yout(i,j+1,k)*smain(i,j+1,k,3)
c    &        +yout(i+1,j,k)*smain(i+1,j,k,4) )
c     enddo
c     enddo
c     enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     boundary terms
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      lh=mx+kend
      ll=2+ksta
      do l=lh,ll,-1
        kmax=min(l-2,kend)
        kmin=max(ksta,l-mx)
      do k=kmax,kmin,-1
        i=l-k
        yout(i,1,k)=yout(i,1,k)-diagmat(i,1,k)*(
     &        yout(i,1,k+1)*smain(i,1,k+1,2)+yout(i,2,k)*smain(i,2,k,3)
     &       +yout(i+1,1,k)*smain(i+1,1,k,4)+yout(i,my,k)*a5 )
      enddo
      enddo
      lh=my+kend
      ll=2+ksta
      do l=lh,ll,-1
        kmax=min(l-2,kend)
        kmin=max(ksta,l-my)
      do k=kmax,kmin,-1
        j=l-k
        yout(1,j,k)=yout(1,j,k)-diagmat(1,j,k)*(
     &        yout(1,j,k+1)*smain(1,j,k+1,2)
     &       +yout(1,j+1,k)*smain(1,j+1,k,3)+yout(2,j,k)*smain(2,j,k,4)
     &       +yout(mx,j,k)*a6 )
      enddo
      enddo
      do k=kend,ksta,-1
        yout(1,1,k)=yout(1,1,k)-diagmat(1,1,k)*(
     &        yout(1,1,k+1)*smain(1,1,k+1,2)+yout(1,2,k)*smain(1,2,k,3)
     &       +yout(2,1,k)*smain(2,1,k,4)
     &       +yout(1,my,k)*a5 +yout(mx,1,k)*a6 )
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c      before vectorize
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do k=kend,ksta,-1
c       do i=mx,2,-1
c         yout(i,1,k)=yout(i,1,k)-diagmat(i,1,k)*(
c    &        yout(i,1,k+1)*smain(i,1,k+1,2)+yout(i,2,k)*smain(i,2,k,3)
c    &       +yout(i+1,1,k)*smain(i+1,1,k,4)+yout(i,my,k)*a5 )
c       enddo
c       do j=my,2,-1
c         yout(1,j,k)=yout(1,j,k)-diagmat(1,j,k)*(
c    &        yout(1,j,k+1)*smain(1,j,k+1,2)
c    &       +yout(1,j+1,k)*smain(1,j+1,k,3)+yout(2,j,k)*smain(2,j,k,4)
c    &       +yout(mx,j,k)*a6 )
c       enddo
c       yout(1,1,k)=yout(1,1,k)-diagmat(1,1,k)*(
c    &        yout(1,1,k+1)*smain(1,1,k+1,2)+yout(1,2,k)*smain(1,2,k,3)
c    &       +yout(2,1,k)*smain(2,1,k,4)
c    &       +yout(1,my,k)*a5 +yout(mx,1,k)*a6 )
c     enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      return
      end
